<?php

class SmartlinkWebhookModuleFrontController extends ModuleFrontController {
	
	public function init(){
      $this->ajax = true;
      parent::init();
      switch ($_SERVER['REQUEST_METHOD']) {
         case 'GET':
            $this->processGetRequest();
            break;
         case 'POST':
            $this->processPostRequest();
            break;
         default:
            // throw some error or whatever
      }
   }

   public function processGetRequest(){

      $this->ajaxRender(json_encode([
         'success' => true,
         'operation' => 'get',
         'message' => 'You should not be here',
      ]));
   }

	public function processPostRequest() {

      $logger = new FileLogger(0); //0 == debug level, logDebug() won’t work without this.
      $logger->setFilename(_PS_ROOT_DIR_."/var/logs/debug.log");
      $logger->logDebug("");
      $logger->logDebug("");
      $logger->logDebug("");
      $logger->logDebug("");
      $logger->logDebug("");
      date_default_timezone_set("UTC");
      $logger->logDebug("Webhook Called");
      $post = Tools::getAllValues();
      $logger->logDebug($post);

		$db = Db::getInstance();
      $sql = "INSERT INTO smartlink_webhook(order_id, trx_id, type, explorer_url, paid_amount, paid_currency, paid_date, confirmation) VALUES('".$post['order_id']."','".$post['txid']."','".$post['type']."','".$post['explorer_url']."','".$post['crypto_amount']."','".$post['crypto_currency']."','".$post['data']."','".$post['confirmations']."')";
      $logger->logDebug($sql);
      $webhookData = $db->Execute($sql);
      $logger->logDebug("=====================");
      $logger->logDebug("Data added in Webhook");

      if($webhookData){
         $order_id = $post['order_id'];
         $user_id = $post['user_id'];
         $crypto_amount = $post['crypto_amount'];
         $crypto_currency = $post['crypto_currency'];
         $trx_id = $post['txid'];
         $status = $post['status'];

         $sql = "UPDATE smartlink_payments
                  SET crypto_amount = '$crypto_amount',
                     crypto_currency = '$crypto_currency',
                     trx_id = '$trx_id',
                     user_id = '$user_id',
                     status = '$status'
                  WHERE order_id = '$order_id'";
         $logger->logDebug($sql);
         $db->Execute($sql);
         $logger->logDebug("=======================");
         $logger->logDebug("Data updated in Payment");

         $order = new Order($order_id);
         $order->setCurrentState(Configuration::get('PS_OS_PAYMENT'));
         $order->save();
      }
	}

	// public function orderCancel($order_id){

   //    $ostate = 6; //canceled order status
	// 	$order = new Order($order_id);
   //    $history = new OrderHistory();
   //    $history->id_order = $order->id;
   //    $history->id_employee = (int) 1;
   //    $history->id_order_state = (int) $ostate;
   //    $history->save();
   //    $history->changeIdOrderState($ostate, $order , true); 
   //    $history->sendEmail($order);
	// }

	// public function orderConfirm($order_id){

   //    $order = new Order($order_id);
   //    $order_current_satus = $order->current_state;
   //    $accepted_payment_status = Configuration::get('smartlink_order_status');
   //    if($order_current_satus != $accepted_payment_status){
   // 		$history = new OrderHistory();
   //       $history->id_order = $order->id;
   //       $history->id_employee = (int) 1;
   //       $history->id_order_state = $accepted_payment_status;
   //       $history->save();
   //       $history->changeIdOrderState($accepted_payment_status, $order , true); 
   //       $history->sendEmail($order);
   //    }
	// }

   // public function checkRaceCondition($transaction_id, $last_id){
	// 	$db = Db::getInstance();
	// 	$sql = "SELECT transaction_id FROM smartlink_webhook WHERE transaction_id= '".$transaction_id."'";
	//    $result = $db->executes($sql);
	// 	if(count($result) > 1) {
	// 		$sql = "DELETE FROM smartlink_webhook WHERE id= '".$last_id."'";
	//       $db->Execute($sql);
	// 	}
	// }
}