$("#pay_now").click(function () {
    web_id = $("#web_id").val();
    fiat_amount = $("#fiat_amount").val();
    fiat_currency = $("#fiat_currency").val();
    order_id = $("#order_id").val();

    ifr = document.createElement('iframe');
    ifr.setAttribute("src", "https://pay.smartlink.so/checkout?web_id=" + web_id + "&amount=" + fiat_amount + "&currency=" + fiat_currency + "&order_id=" + order_id);
    ifr.style.width = "100%";
    ifr.style.height = "100vh";
    ifr.style.position = "fixed";
    ifr.style.left = "0";
    ifr.style.top = "0";
    ifr.style.border = "0";
    ifr.style.zIndex = "2147483647";
    // ifr.setAttribute("allowpaymentrequest", true)
    // ifr.setAttribute("credentialless", true)
    // ifr.allowpaymentrequest =true; 
    ifr.id = "checkout-frame";
    ifr.setAttribute("class", "checkout-frame-class");
    ifr.setAttribute("sandbox", "allow-top-navigation allow-same-origin allow-scripts allow-popups allow-forms");
    ifr.setAttribute("allow", "fullscreen");
    // btn.parentNode.insertBefore(ifr, btn);
    document.body.appendChild(ifr)
});

$(document).ready(function () {
    ajaxCall();
    // setInterval(ajaxCall, 5000);
});

window.addEventListener('message', function (event) {
    if (event.data === 'WebhookCalledTimer') {
        setInterval(function () {
            ajaxCall();
        }, 5000);
    }
});

function ajaxCall() {
    var order_id = $("#order_id").val();
    $.ajax({
        url: "index.php?controller=paymenthistory&fc=module&module=smartlink",
        type: "POST",
        data: { order_id },
    }).done(function (result) {
        result = JSON.parse(result);
        console.log(result);
        if (result.flag == 1) {
            $("#paid-amt").text(result.data.paid_amount + " " + result.data.currency);
            $("#pending-amt").text(result.data.pending_amount + " " + result.data.currency);
            paymenthistory = '<div class="cr-plugin-history-box no-history-found"><div class="cr-plugin-history"><div class="cr-plugin-history-des" style="text-align: center;"><p><span style="color: green;">' + result.msg + '</span></p></div></div></div>';
            $('#pay_now').css("display", 'none');
            $('#trx_id').html('<li>transaction ID <a href="' + result.data.explorer_url + result.data.trx_id + '" target="blank"><span style="font-size: smaller; font-weight: bold;">' + result.data.trx_id.substring(0, 30) + '...</span></a></li>');
        } else if (result.flag == 2) {
            window.open("index.php?controller=invoice&fc=module&module=smartlink&order_id=" + order_id, "_SELF");
        } else {
            $("#paid-amt").text(result.data.paid_amount + " " + result.data.currency);
            $("#pending-amt").text(result.data.pending_amount + " " + result.data.currency);
            paymenthistory = '<div class="cr-plugin-history-box no-history-found"><div class="cr-plugin-history"><div class="cr-plugin-history-des" style="text-align: center;"><p><span style="color: red;">' + result.msg + '</span></p></div></div></div>';
        }
        $("#cr-plugin-history-list").html(paymenthistory);
        return true;
    });
}
window.addEventListener('message', function (event) {
    
    if (event.data === 'iframeClosed') {
        document.getElementById('checkout-frame').remove()
    }
});