<div class="box">
   <h3>{l s=' Payment Detail (smartlink) ' d='Shop.Theme.Customeraccount'}</h3>
   <div style="overflow-y:auto">
      <table class="table table-bordered">
         <thead class="thead-default">
            <tr>
               <th>{l s='Currency' d='Shop.Theme.Global'}</th>
               <th>{l s='Total Amount' d='Shop.Theme.Checkout'}</th>
               <th>{l s='Paid Amount' d='Shop.Theme.Checkout'}</th>
               <th>{l s='Pending Amount' d='Shop.Theme.Checkout'}</th>
               <th>{l s='Payment Status' d='Shop.Theme.Checkout'}</th>
               <th>{l s='Date ' d='Shop.Theme.Checkout'}</th>
            </tr>
         </thead>
         <tbody>
            <tr>
               <td>{$currency}</td>
               <td>{$total_amount} {$currency}</td>
               <td>{$paid_amount} {$currency}</td>
               <td>{$pending_amount} {$currency}</td>
               <td>{$status}</td>
               <td>{$date}</td>
            </tr>
         </tbody>
      </table>
   </div>
   <table class="table table-bordered">
      <thead class="thead-default">
         <tr>
            <th>{l s='Transaction Ids' d='Shop.Theme.Global'}</th>
         </tr>
      </thead>
      <tbody>
         {if isset($payment_history) && count($payment_history)} 
            {foreach from=$payment_history item=phistory}
               <tr>
                  <td><a href="{$phistory['explorer_url']}{$phistory['txid']}" target="_blank">{substr($phistory['txid'],0,30)}...</a></td>
               </tr>
            {/foreach}
         {else}
            <tr><td style="text-align: center;">-</td></tr>
         {/if}
      </tbody>
   </table>
   <div>
      {if ($status=="Pending")}
      <div class="form-footer text-sm-center">
         <a class="btn btn-primary form-control-submit" href="{$invoice_url}">
            Pay Now
         </a>
      </div>
      {/if}
   </div>
</div>